Imports System.Xml

Public Class myStatus

  Inherits System.Web.UI.Page

  Protected WithEvents Label2 As System.Web.UI.WebControls.Label
  Protected WithEvents Label3 As System.Web.UI.WebControls.Label
  Protected WithEvents Label1 As System.Web.UI.WebControls.Label
  Protected WithEvents LastUpdatedLabel As System.Web.UI.WebControls.Label
  Protected WithEvents TextBoxName As System.Web.UI.WebControls.TextBox
  Protected WithEvents TextBoxBack As System.Web.UI.WebControls.TextBox
  Protected WithEvents TextBoxReach As System.Web.UI.WebControls.TextBox
  Protected WithEvents DropDownListCurrently As System.Web.UI.WebControls.DropDownList
  Protected WithEvents TextBoxEmergency As System.Web.UI.WebControls.TextBox
  Protected WithEvents Button1 As System.Web.UI.WebControls.Button

#Region " Web Form Designer Generated Code "

  'This call is required by the Web Form Designer.
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

  End Sub

  Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
    'CODEGEN: This method call is required by the Web Form Designer
    'Do not modify it using the code editor.
    InitializeComponent()
  End Sub

#End Region

  Private Sub Page_Load(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles MyBase.Load

    'purpose: check if the user has a valid cookie from a prior visit
    '         if so, grab their XML file and fill form fields
    '         if not, simply display the form

    'local scope
    Dim userSessionId As String

    'get the session id (if any)
    If Not IsNothing(Request.Cookies("UserSession")) Then
      userSessionId = Request.Cookies("UserSession").Value
    End If

    'check for cookie
    If userSessionId <> "" Then

      'block scope
      Dim xReader As XmlTextReader

      'get xml file, parse, and write to form field values
      'create new xml reader object
      xReader = New XmlTextReader( _
        url:=Request.PhysicalApplicationPath & _
        "\fileStore\" & userSessionId & ".xml")

      'read items out of the file and update set values on the form
      xReader.WhitespaceHandling = WhitespaceHandling.None
      While xReader.Read()

        'check for element nodes
        Select Case xReader.NodeType
          Case XmlNodeType.Element

            'check for each element and update control
            Select Case xReader.Name
              Case "TextBoxName"
                TextBoxName.Text = xReader.ReadString()

              Case "TextBoxBack"
                TextBoxBack.Text = xReader.ReadString()

              Case "TextBoxReach"
                TextBoxReach.Text = xReader.ReadString()

              Case "DropDownListCurrently"
                DropDownListCurrently.Items.FindByValue( _
                xReader.ReadString()).Selected = True

              Case "TextBoxEmergency"
                TextBoxEmergency.Text = xReader.ReadString()

              Case "LastUpdated"
                LastUpdatedLabel.Text = xReader.ReadString()

            End Select

        End Select

      End While

      'cose the reader
      xReader.Close()

    Else

      'set the last updated text box to nothing
      LastUpdatedLabel.Text = ""

    End If

  End Sub

  Private Sub Button1_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles Button1.Click

    'purpose: respond to update button (user submit)
    '         update the user's XML data file

    'local scope
    Dim origSessionId As String

    'check for the user's cookie, if not write out
    If Not IsNothing(Request.Cookies("UserSession")) Then
      origSessionId = Request.Cookies.Item("UserSession").Value.ToString
    End If

    'check for a cookie value
    If origSessionId = "" Then

      'block scope
      Dim myCookie As HttpCookie

      'no cookie exists, write one out
      origSessionId = Session.SessionID

      'create a cookie
      myCookie = New HttpCookie( _
        name:="UserSession", _
        value:=origSessionId)

      'set the cookie's expiration date to be one month from now
      myCookie.Expires = DateAdd(DateInterval.Month, 1, Now)

      'add the cookie to the response
      Response.Cookies.Add(cookie:=myCookie)

    End If

    'add each form element to the xml stream
    Dim xWriter As XmlTextWriter

    'creates a new xml text writer object
    'if the file exists it will write over it (nothing=UTF-8)
    xWriter = New XmlTextWriter( _
      filename:=(Request.PhysicalApplicationPath & _
      "\fileStore\" & origSessionId & ".xml"), _
      encoding:=Nothing)

    'write the xml out to the file
    'start the xml element
    xWriter.WriteStartElement(localName:="Status")

    'add the sessionid to the status element as an attribute
    xWriter.WriteAttributeString( _
      localName:="UserSession", _
      value:=origSessionId)

    'write each form field as an xml element
    xWriter.WriteElementString( _
      localName:="TextBoxName", _
      value:=Request.Form("TextBoxName").ToString)

    xWriter.WriteElementString( _
      localName:="TextBoxBack", _
      value:=Request.Form("TextBoxBack").ToString)

    xWriter.WriteElementString( _
      localName:="TextBoxReach", _
      value:=Request.Form("TextBoxReach").ToString)

    xWriter.WriteElementString( _
      localName:="DropDownListCurrently", _
      value:=Request.Form("DropDownListCurrently").ToString)

    xWriter.WriteElementString( _
      localName:="TextBoxEmergency", _
      value:=Request.Form("TextBoxEmergency").ToString)

    xWriter.WriteElementString( _
      localName:="LastUpdated", _
      value:=Now.ToString)

    'end the element
    xWriter.WriteEndElement()

    'close the xml stream
    xWriter.Close()

    'redirect the user back to the home page
    Response.Redirect("home.aspx")

  End Sub

End Class
